import type { List } from "../utils/generics.js";
import type { IntersectionState } from "./compose.js";
import type { Branch, PredicateComparison } from "./predicate.js";
export declare const isBranchComparison: (comparison: PredicateComparison) => comparison is BranchesComparison;
export type Branches = List<Branch>;
export type BranchesComparison = {
    lBranches: Branches;
    rBranches: Branches;
    lExtendsR: number[];
    rExtendsL: number[];
    equalities: [lIndex: number, rIndex: number][];
    distinctIntersections: Branches;
};
export declare const compareBranches: (lConditions: Branches, rConditions: Branches, state: IntersectionState) => BranchesComparison;
