import type { Dict } from "../../utils/generics.js";
import type { DefaultObjectKind } from "../../utils/objectKinds.js";
import type { TraversalNode, TypeNode } from "../node.js";
import type { FlattenAndPushRule } from "./rules.js";
export type ObjectKindRule<$ = Dict> = DefaultObjectKind | readonly ["Array", TypeNode<$>] | readonly ["Array", TypeNode<$>] | readonly ["Set", TypeNode<$>] | readonly ["Map", TypeNode<$>, TypeNode<$>];
export type TraversalObjectKindRule = DefaultObjectKind | readonly ["Array", TraversalNode] | readonly ["Array", TraversalNode] | readonly ["Set", TraversalNode] | readonly ["Map", TraversalNode, TraversalNode];
export declare const objectKindIntersection: import("../compose.js").Intersector<ObjectKindRule<Dict> | undefined>;
export declare const objectKindPathSegments: {
    readonly "${number}": true;
    readonly "${item}": true;
    readonly "${key}": true;
    readonly "${value}": true;
};
export type ObjectKindPathSegment = keyof typeof objectKindPathSegments;
export declare const flattenObjectKind: FlattenAndPushRule<ObjectKindRule>;
