import type { Dict } from "../../utils/generics.js";
import type { TraversalNode, TypeNode } from "../node.js";
import type { FlattenAndPushRule } from "./rules.js";
export type PropsRule<$ = Dict> = {
    [propKey in string]: Prop<$>;
};
export type Prop<$ = Dict> = TypeNode<$> | OptionalProp<$>;
export type OptionalProp<$ = Dict> = ["?", TypeNode<$>];
export type TraversalRequiredProps = [
    "requiredProps",
    readonly TraversalPropEntry[]
];
export type TraversalOptionalProps = [
    "optionalProps",
    readonly TraversalPropEntry[]
];
export type TraversalPropEntry = [propKey: string, node: TraversalNode];
export declare const isOptional: (prop: Prop) => prop is OptionalProp<Dict>;
export declare const propsIntersection: import("../compose.js").Intersector<PropsRule<Dict> | undefined>;
export declare const flattenProps: FlattenAndPushRule<PropsRule>;
